LIST	P=16F628A, R=DEC
INCLUDE	"P16F628A.INC"
	
TMP_W	EQU	20H	; ZALOHA WORK
TMP_S	EQU	21H	; ZALOHA STATUS
TMP_D	EQU	22H
TMP_C3	EQU	23H
PRIZNAK	EQU	24H
FMSB	EQU 	25H
FLSB	EQU	26H
COUNT	EQU	27H
TMP2	EQU 	28H
TMP1	EQU 	29H
PWMreg	EQU	2AH
PWM_MAX	EQU	2BH
duty	EQU	2CH
FLAG2	EQU	2DH
TMP0	EQU	30H
CISLA01	EQU	31H
CISLA23	EQU	32H
CISLA45	EQU	33H
CISLA67	EQU	34H
CISLA89	EQU	35H
RTCCPOM	EQU	36H
FMMSB	EQU	37H
FLAG	EQU	38H
priznak	EQU	39H
TMP_C4	EQU	3AH
rozsah	EQU	3BH
pospre	EQU	3FH
Wtemp	EQU	72H
Stemp	EQU	71H
Tpclath	EQU	70H
dutytemp EQU 73H
stovky	EQU	74H
desiatky EQU 75H
jednotky EQU 76H

#DEFINE	RS		PORTA,7
#DEFINE	E		PORTA,6
#DEFINE	PWM	 	PORTB,5
#DEFINE	TL1		PORTB,6
#DEFINE	TL2		PORTB,7
#DEFINE	SIG		PORTA,4

		ORG	0X2007		; ADRESA KONFIGURACE PIC16F627 A 628
	DW _BODEN_OFF & _CP_OFF & _PWRTE_ON & _WDT_OFF & _LVP_OFF & _MCLRE_ON & _INTOSC_OSC_NOCLKOUT

	ORG	0X0000		; ZACIATOK PROGRAMU
			GOTO	START	; SKOK NA INICIALIZACIU

	ORG	0X0004		; VEKTOR PRERUSENIA
			GOTO	PRERUS



;PRERUSENIE

PRERUS			movwf	Wtemp
			movfw	PCLATH
			movwf	Tpclath
			movfw	STATUS
			movwf	Stemp
			clrf	PCLATH

			btfsc	FLAG2,0
			goto	pwmgen			

			btfss	TL1
			goto	tl1on
			btfss	TL2
			goto	tl2on

			bcf		INTCON, 0
			movfw	Tpclath
			movwf	PCLATH
			movfw	PORTB
			movfw	Stemp
			movwf	STATUS
			swapf	Wtemp,F
			swapf	Wtemp,W	
			
			retfie
;-------------------------------------------


tl1on			incf	rozsah
			movlw	6
			subwf	rozsah, W
			btfsc	STATUS,Z
			goto	$+2
			goto	zmeroz
			movlw	0
			movwf	rozsah
			goto	zmeroz

tl2on			movlw	1
			subwf	rozsah,f
			btfsc	STATUS,C
			goto	$+3
			movlw	5
			movwf	rozsah
			goto	zmeroz
;-------------------------------

zmeroz	
			movfw	rozsah
			addwf	PCL
			goto	r1
			goto	r2
			goto	r3
			goto	r4
			goto	r5
			goto	r6

r1			MOVLW	01h
			CALL	WRCMD
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'1'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'H'
			CALL	WRDATA
			MOVLW	'z'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'-'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'2'
			CALL	WRDATA
			MOVLW	'0'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'H'
			CALL	WRDATA
			MOVLW	'z'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			goto	real


r2			MOVLW	01h
			CALL	WRCMD
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'1'
			CALL	WRDATA
			MOVLW	'0'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'H'
			CALL	WRDATA
			MOVLW	'z'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'-'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'2'
			CALL	WRDATA
			MOVLW	'0'
			CALL	WRDATA
			MOVLW	'0'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'H'
			CALL	WRDATA
			MOVLW	'z'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			goto	real



r3			MOVLW	01h
			CALL	WRCMD
			MOVLW	'1'
			CALL	WRDATA
			MOVLW	'0'
			CALL	WRDATA
			MOVLW	'0'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'H'
			CALL	WRDATA
			MOVLW	'z'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'-'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'2'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'k'
			CALL	WRDATA
			MOVLW	'H'
			CALL	WRDATA
			MOVLW	'z'
			CALL	WRDATA
			movlw	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			goto	real


r4			MOVLW	01h
			CALL	WRCMD
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'1'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'k'
			CALL	WRDATA
			MOVLW	'H'
			CALL	WRDATA
			MOVLW	'z'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'-'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'2'
			CALL	WRDATA
			MOVLW	'0'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'k'
			CALL	WRDATA
			MOVLW	'H'
			CALL	WRDATA
			MOVLW	'z'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			goto	real

r5			MOVLW	01h
			CALL	WRCMD
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'1'
			CALL	WRDATA
			MOVLW	'0'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'k'
			CALL	WRDATA
			MOVLW	'H'
			CALL	WRDATA
			MOVLW	'z'
			CALL	WRDATA
			MOVLW	'-'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'2'
			CALL	WRDATA
			MOVLW	'O'
			CALL	WRDATA
			MOVLW	'0'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'k'
			CALL	WRDATA
			MOVLW	'H'
			CALL	WRDATA
			MOVLW	'z'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			goto	real

r6			MOVLW	01h
			CALL	WRCMD
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'1'
			CALL	WRDATA
			MOVLW	'0'
			CALL	WRDATA
			MOVLW	'0'
			CALL	WRDATA
			MOVLW	'k'
			CALL	WRDATA
			MOVLW	'H'
			CALL	WRDATA
			MOVLW	'z'
			CALL	WRDATA
			MOVLW	'-'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'1'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'M'
			CALL	WRDATA
			MOVLW	'H'
			CALL	WRDATA
			MOVLW	'z'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			goto	real
;---------------------------------------------

real			movfw	PORTA
			andlw	b'00000111'
			subwf	PORTA
                        comf	rozsah, W
			andlw	b'00000111'
			addwf	PORTA
			bcf	INTCON, 0
			movfw	Tpclath
			movwf	PCLATH
			movfw	PORTB
			movfw	Stemp
			movwf	STATUS
			swapf	Wtemp,F
			swapf	Wtemp,W	
 	
		
			retfie
		

;------------------------------------------------------
;PWM int
;-------
pwmgen		movlw	200		 
			movwf	TMR0
			bcf	INTCON, T0IF
			
			incf	PWMreg
			movfw	PWMreg
			subwf	duty, W
			btfsc	STATUS,C
			goto	aktiv
			goto	deaktiv

aktiv 			bcf	PWM
			goto	von
deaktiv			bsf	PWM
			goto	von

von			movfw	Tpclath
			movwf	PCLATH
			bcf	INTCON, T0IF
			movfw	Stemp
			movwf	STATUS
			swapf	Wtemp,F
			swapf	Wtemp,W	
 	
		
			retfie
					
       ;--------------------------------------------------------


START	
			bsf	STATUS,RP0	; banka registru 1
			movlw	b'00011000'
			movwf	TRISA
			movlw	b'11000000'		;1-vstup, 0-vystup 
			movwf	TRISB
			bcf	STATUS,RP0	; banka registru 0
			movlw	b'00000000'
			movwf	PORTA
			movlw	b'00000111'
			movwf	PORTB
			movlw	b'00000111'	
			movwf	CMCON 
			bsf	STATUS,RP0
			movlw	b'00011111'	; PULL-UPy ON, INT na dobeznu hranu, preddelic=1:4 pripojen k TMR0
			movwf	OPTION_REG
			bcf	STATUS,RP0
			clrf	INTCON
			CALL	INILCD
			clrf	FLAG2

;----------------------------------------
;volba cinnosti riadenia - PWM vs F-generator


			MOVLW	01h
			CALL	WRCMD
			MOVLW	' '
			CALL	WRDATA
			call	cakdi
			MOVLW	' '
			CALL	WRDATA
			call	cakdi
			MOVLW	'P'
			CALL	WRDATA
			call	cakdi
			MOVLW	'W'
			CALL	WRDATA
			call	cakdi
			MOVLW	'M'
			CALL	WRDATA
			call	cakdi
			MOVLW	' '
			CALL	WRDATA
			call	cakdi
			MOVLW	'v'
			CALL	WRDATA
			call	cakdi
			MOVLW	's'
			CALL	WRDATA
			call	cakdi
			MOVLW	' '
			CALL	WRDATA
			call	cakdi
			MOVLW	'F'
			CALL	WRDATA
			call	cakdi
			MOVLW	'-'
			CALL	WRDATA
			call	cakdi
			MOVLW	'g'
			CALL	WRDATA
			call	cakdi
			MOVLW	'e'
			CALL	WRDATA
			call	cakdi
			MOVLW	'n'
			CALL	WRDATA
			call	cakdi
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA

			movlw	192		
			call	WRCMD       
			MOVLW	' '
			CALL	WRDATA
			call	cakdi
			MOVLW	' '
			CALL	WRDATA
			call	cakdi
			MOVLW	'T'
			CALL	WRDATA
			call	cakdi
			MOVLW	'l'
			CALL	WRDATA
			call	cakdi
			MOVLW	'.'
			CALL	WRDATA
			call	cakdi
			MOVLW	'1'
			CALL	WRDATA
			call	cakdi
			MOVLW	' '
			CALL	WRDATA
			call	cakdi
			MOVLW	' '
			CALL	WRDATA
			call	cakdi
			MOVLW	' '
			CALL	WRDATA
			call	cakdi
			MOVLW	'T'
			CALL	WRDATA
			call	cakdi
			MOVLW	'l'
			CALL	WRDATA
			call	cakdi
			MOVLW	'.'
			CALL	WRDATA
			call	cakdi
			MOVLW	'2'
			CALL	WRDATA
			call	cakdi
			MOVLW	' '
			CALL	WRDATA
			call	cakdi
			MOVLW	' '
			CALL	WRDATA
			call	cakdi

			btfss	TL2
			goto	pwgen
			btfss	TL1
			goto	fungen
			goto	$-4
			
pwgen		bsf		FLAG2,0	
			bsf	STATUS,RP0
			movlw	b'00011111'	; PULL-UPy ON, INT na dobeznu hranu, preddelic=1:4 pripojen k TMR0
			movwf	OPTION_REG	
			bcf	STATUS,RP0
			movlw	b'00100000'	;  soft TMR0
			movwf	INTCON
			
			MOVLW	01h
			CALL	WRCMD
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'P'
			CALL	WRDATA
			call	cakdi
			MOVLW	'W'
			CALL	WRDATA
			call	cakdi
			MOVLW	'M'
			CALL	WRDATA
			call	cakdi
			MOVLW	'-'
			CALL	WRDATA
			call	cakdi
			MOVLW	'G'
			CALL	WRDATA
			call	cakdi
			MOVLW	'e'
			CALL	WRDATA
			call	cakdi
			MOVLW	'n'
			CALL	WRDATA
			call	cakdi
			MOVLW	'e'
			CALL	WRDATA
			call	cakdi
			MOVLW	'r'
			CALL	WRDATA
			call	cakdi
			MOVLW	'a'
			CALL	WRDATA
			call	cakdi
			MOVLW	't'
			CALL	WRDATA
			call	cakdi
			MOVLW	'o'
			CALL	WRDATA
			call	cakdi
			MOVLW	'r'
			CALL	WRDATA
		

			movlw	192		
			call	WRCMD       
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'A'
			CALL	WRDATA
			call	cakdi
			MOVLW	'.'
			CALL	WRDATA
			call	cakdi
			MOVLW	'K'
			CALL	WRDATA
			call	cakdi
			MOVLW	'.'
			CALL	WRDATA
			call	cakdi
			MOVLW	' '
			CALL	WRDATA
			call	cakdi
			MOVLW	'2'
			CALL	WRDATA
			call	cakdi
			MOVLW	'0'
			CALL	WRDATA
			call	cakdi
			MOVLW	'0'
			CALL	WRDATA
			call	cakdi
			MOVLW	'9'
			CALL	WRDATA
		
		
			call	cakSEK
			call	cakSEK
			call	cakSEK
			call	cakSEK
			call	cakSEK
			call	cakSEK
			call	cakSEK
			call	cakSEK

			goto	pwgenreal





fungen			bcf	FLAG2,0	
			bsf	STATUS,RP0
			movlw	b'00100111'	; PULL-UPy ON, INT na dobeznu hranu, preddelic=1:4 pripojen k TMR0
			movwf	OPTION_REG	
			bcf	STATUS,RP0
			
			CLRF	PRIZNAK
			CLRF	FLAG
			CLRF	FMMSB
			CLRF	FMSB
			CLRF	RTCCPOM
			CLRF	FLSB
			movlw	0 
			movwf	rozsah
			BSF	PORTA,0
			BSF	PORTA,1
			BSF	PORTA,2

;uvodna sprava - test LCD a komunikacie

			MOVLW	01h
			CALL	WRCMD
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'F'
			CALL	WRDATA
			call	cakdi
			MOVLW	'-'
			CALL	WRDATA
			call	cakdi
			MOVLW	'G'
			CALL	WRDATA
			call	cakdi
			MOVLW	'e'
			CALL	WRDATA
			call	cakdi
			MOVLW	'n'
			CALL	WRDATA
			call	cakdi
			MOVLW	'e'
			CALL	WRDATA
			call	cakdi
			MOVLW	'r'
			CALL	WRDATA
			call	cakdi
			MOVLW	'a'
			CALL	WRDATA
			call	cakdi
			MOVLW	't'
			CALL	WRDATA
			call	cakdi
			MOVLW	'o'
			CALL	WRDATA
			call	cakdi
			MOVLW	'r'
			CALL	WRDATA
			call	cakdi
	
			movlw	192		
			call	WRCMD       
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'A'
			CALL	WRDATA
			call	cakdi
			MOVLW	'.'
			CALL	WRDATA
			call	cakdi
			MOVLW	'K'
			CALL	WRDATA
			call	cakdi
			MOVLW	'.'
			CALL	WRDATA
			call	cakdi
			MOVLW	' '
			CALL	WRDATA
			call	cakdi
			MOVLW	'2'
			CALL	WRDATA
			call	cakdi
			MOVLW	'0'
			CALL	WRDATA
			call	cakdi
			MOVLW	'0'
			CALL	WRDATA
			call	cakdi
			MOVLW	'9'
			CALL	WRDATA
			call	cakdi
			
			call	cakSEK
			call	cakSEK
			call	cakSEK
			call	cakSEK
			call	cakSEK
			call	cakSEK
			call	cakSEK
			call	cakSEK	

			movlw	1
			CALL	WRCMD
			MOVLW	' '
			CALL	WRDATA	
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'1'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'H'
			CALL	WRDATA
			MOVLW	'z'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'-'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'2'
			CALL	WRDATA
			MOVLW	'0'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	'H'
			CALL	WRDATA
			MOVLW	'z'
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
			MOVLW	' '
			CALL	WRDATA
            		movlw	b'11001000'	; prerusenia od zmeny na porte B - teda pre tlacitka
			movwf	INTCON




CITAC			CLRF	PRIZNAK
			CLRF	FMMSB
			CLRF	FMSB
			CLRF    TMR0
			CLRF	FLSB

			CALL	INCFMSB
			BTFSC	INTCON,2
			INCF	FMSB,F		;ESTE RAZ POZRI CI NEPRETIKOL RTCC
	      
			CALL	PREDDEL		;ZISTI OBSAH V PREDDELICKE

			MOVFW	TMR0
			MOVWF	RTCCPOM


ZOBCIT	CALL	B32_BCD		;A CELE 32 BITOVE CISLO PREMENI NA BCD KOD
;...............................................................................................
	MOVFW	CISLA67
	BTFSS	STATUS,Z		;AK JE REGISTER NENULOVY TAK FREKVENCIA JE V MHZ
	BSF	PRIZNAK,1
	BCF	PRIZNAK,1
	MOVLW	192
	CALL	WRCMD		;DD RAM =0,OBSAH BEZ ZMENY
	MOVLW	'f'
	CALL	WRDATA
	MOVLW	'='
	CALL	WRDATA
	
	SWAPF	CISLA67,F
	MOVFW	CISLA67
	ANDLW	0FH		;ODMASKUJ 7. RAD
	BTFSC	STATUS,Z
	BSF	PRIZNAK,2	;AK JE TO NULA TAK NASTAV PRIZNAK
	BTFSS	STATUS, Z
	goto	$+3
	movlw	' '
	goto	$+2
	ADDLW	30H		;ZOBRAZ HO IBA AK JE NENULOVE
	CALL	WRDATA

	SWAPF	CISLA67,F
	MOVFW	CISLA67
	ANDLW	0FH		;ODMASKUJ 6. RAD
	BTFSS	STATUS,Z
	GOTO	CIT2		;AK JE NENULOVE TAK HO ZOBRAZ
	BTFSC	PRIZNAK,2	;INAK POZRI CI AJ PRED NIM BOLA NULA
	GOTO	CIT3		;BOLA NEZOBRAZUJHO
CIT2	BCF	PRIZNAK,2	;NENULOVE CISLO => VYPNI PRIZNAK NULY
		ADDLW	30H		;AK JE NENULOVE TAK HO ZOBRAZ
		goto	$+2
CIT3	movlw	' '
		CALL	WRDATA

		BTFSS	PRIZNAK,1	; priznak  MHZ
		goto	$+3
		movlw	','
		call 	WRDATA

	SWAPF	CISLA45,F
	MOVFW	CISLA45
	ANDLW	0FH		;ODMASKUJ 5. RAD
	btfsc	PRIZNAK,1
	goto	SKOK2	

	BTFSS	STATUS,Z
	GOTO	SKOK2		;AK JE CISLO NENULOVE TAK HO ZOBRAZ
	BTFSC	PRIZNAK,2	;POZRI CI PRED NIM BOLY NULY
	GOTO	SKOK3		;BOLY => NEZOBRAZUJ HO
SKOK2	BCF	PRIZNAK,2	;NENULOVE CISLO => VYNULUJ PRIZNAK NULY
		ADDLW	30H
		goto	$+2
SKOK3	movlw	' '
		CALL	WRDATA

	SWAPF	CISLA45,F
	MOVFW	CISLA45
	ANDLW	0FH		;ODMASKUJ 4. RAD
	btfsc	PRIZNAK,1
	goto	SKOK4
	BTFSS	PRIZNAK,2	;AK PRED NIM BOLO NENULOVE CISLO TAK HO ZOBRAZ
	GOTO	SKOK4
	BTFSC	STATUS,Z		;AK JE TO NULA TAK NIC NEZOBRAZUJ
	GOTO	SKOK5
SKOK4	BCF	PRIZNAK,2	;NENULOVE CISLO => VYNULUJ PRIZNAK NULY
		ADDLW	30H
		goto	$+2
SKOK5	movlw	' '
		CALL	WRDATA

	;	btfsc	PRIZNAK,1
	;	GOTO	SKOK6
	;	MOVLW	','
	;	CALL	WRDATA
	
SKOK6	SWAPF	CISLA23,F
	MOVFW	CISLA23
	ANDLW	0FH		;ODMASKUJ 3.RAD (JE ZOBRAZENY VZDY)
	ADDLW	30H
	CALL	WRDATA

	BTFSC	PRIZNAK,1
	GOTO	SKOK7
	MOVLW	','
	CALL	WRDATA
	
SKOK7	SWAPF	CISLA23,F
	MOVFW	CISLA23
	ANDLW	0FH		;ODMASKUJ 2.RAD A ZOBRAZ HO (JE ZOBRAZENY VZDY)
	ADDLW	30H
	CALL	WRDATA	

	SWAPF	CISLA01,F
	MOVFW	CISLA01
	ANDLW	0FH		;ODMASKUJ 1. RAD
	ADDLW	30H
	CALL	WRDATA

	SWAPF	CISLA01,F
	MOVFW	CISLA01
	ANDLW	0FH		;ODMASKUJ 0-TY RAD
	ADDLW	30H
	CALL	WRDATA

	MOVLW	' '
	CALL	WRDATA

	BTFSC	PRIZNAK,1
	GOTO	$+4
	MOVLW	'k'
	CALL	WRDATA
	GOTO	$+3
	MOVLW	'M'
	CALL	WRDATA
	MOVLW	'H'
	CALL	WRDATA
	MOVLW	'z'
	CALL	WRDATA

	goto	CITAC

;----------------------------------------------------

pwgenreal	movlw	126
		movwf	duty		; nastavena polovicna strieda
		bsf	INTCON, GIE
		goto	loop2
		
loop	BTFSS	TL1
		goto	inpowm
		BTFSS	TL2
		goto	depowm
		goto	$-4

inpowm		btfss	TL1
		goto	$-1
		movlw	5
		addwf	duty,F
		goto	loop2

depowm		btfss	TL2
		goto	$-1
		movlw	5
		subwf	duty,F
		goto	loop2

loop2		MOVLW	01h
		CALL	WRCMD
		MOVLW	'D'
		CALL	WRDATA
		MOVLW	'u'
		CALL	WRDATA
		MOVLW	't'
		CALL	WRDATA
		MOVLW	'y'
		CALL	WRDATA
		MOVLW	' '
		CALL	WRDATA
		MOVLW	'c'
		CALL	WRDATA
		MOVLW	'y'
		CALL	WRDATA
		MOVLW	'c'
		CALL	WRDATA
		MOVLW	'l'
		CALL	WRDATA
		MOVLW	'e'
		CALL	WRDATA
		MOVLW	':'
		CALL	WRDATA
		MOVLW	' '
		call	WRDATA
	; vypocitame potrebne udaje - vstup "duty" - na BCD tvar

		movfw	duty
		movwf	dutytemp
		clrf	stovky
		clrf	desiatky
		clrf	jednotky


		movlw	100
		subwf	dutytemp,W
		btfss	STATUS,C
		goto	desrat
		incf	stovky
		movwf	dutytemp
		goto	$-6
;-------------hotove stovky-----------------
desrat	movlw	10
		subwf	dutytemp,w
		btfss	STATUS,C
		goto	jedrat
		incf	desiatky
		movwf	dutytemp
		goto	$-6
;-----------hotove desiatky----------------
jedrat	movfw	dutytemp
		movwf	jednotky
;-----------hotove jednotky------------------



		movlw	30h
		addwf	stovky,W
		CALL	WRDATA
		movlw	30h
		addwf	desiatky,W
		CALL	WRDATA
		movlw	30h
		addwf	jednotky,W
		CALL	WRDATA

; teraz zobrazime duty cycle graficky:
		movlw	192
		call	WRCMD

		movfw	duty
		movwf	dutytemp
		movlw	16
		subwf	dutytemp,f
		btfss	STATUS,C
		goto	loop
		movlw	10
		call	WRDATA
		goto	$-6


;PODPROGRAMY:
;---------------------------
;************ PODPROGRAM ,KTORY INCREMENTJE REGISTER FMSB POCAS MERACEJ PERIODY **************
INCFMSB		MOVLW	216		; 216 DEFAULT
			MOVWF	TMP0
			MOVLW	99		;99 default		
			MOVWF	TMP1
			MOVLW	2
			MOVWF	TMP2
SLUCKA		BTFSS	INTCON,2	;DOSLO K PRETECENIU RTCC?
			GOTO	KOMPENZ		;NIE => KOMPENZUJ CAS TRVANIA INCREMENTACIE A MAZANIA PRIZNAKU
			BCF	INTCON,2	;ANO => INCREMENTUJ REGISTER FMSB A ZMAZ PRIZNAK PRETECENIA
			INCFSZ	FMSB,F
			GOTO	SLUCKA2
			INCF	FMMSB,F
SLUCKA2		GOTO	SLUCKA1
KOMPENZ		NOP			;PO SKOKU NA KOMPENZ BUDE SLUCKA TRVAT ROVNAKO DLHO AKO  
			NOP			;KED SA INCREMENTUJE REGISTER FMSB A NULUJE PRIZNAK
			NOP	
			GOTO	SLUCKA1
SLUCKA1		DECFSZ	TMP0,F
			GOTO	SLUCKA
			DECFSZ	TMP1,F
			GOTO	SLUCKA
			DECFSZ	TMP2,F
			GOTO	SLUCKA
			movlw	13
			movwf	pospre
			decfsz	pospre
			goto	$-1
			nop
			RETURN

;**********************PODPROGRAM CO ZISTI OBSAH PREDDELICKY ************************************

PREDDEL bsf	STATUS,RP0
	bcf	TRISA,3
        bcf	STATUS,RP0

	MOVFW   TMR0                    ;HODNOTU Z RTCC ULOZ V REGISTRI TMP0
        MOVWF   TMP0                     
        CLRF    COUNT                   ;VYNULUJ POCITADLO PREPNUTI
	CLRF	FLSB			;VYNULUJ NAJNIZSI BYTE FREKVENCIE
PREPNI  
        INCF    COUNT,F                 ;INCREMENTUJ POCITADLO PREPNUTI
;.................OSETERNIE NULY........................
	BTFSC	STATUS,Z				;AK NACITAL 256 IMPULZOV (COUNT = 0) TAK TO ZNAMENA ZE V PREDDELICKE BOLA 0 
	GOTO	PREPNI1			;TEDA FLSB OSTANE 0 A ANI RTCC SA ESTE NEZMENILO => VRAT POVODNU HODNOTU DO RTCC
;.......................................................	
     	  BCF     PORTA,3                    ;PREPNI VSTUP
	NOP
        BSF     PORTA,3                    ;       /
        MOVFW   TMR0                    ;POZRI SA CI SA ZMENILA HODNOTA V RTCC
        SUBWF   TMP0,W                  ;       /
        BTFSC   STATUS,Z                   
        GOTO    PREPNI                  ;NEZMENILA -> OPAT PREPNI
        COMF    COUNT,F                 ;ZMENILA => ZNEGUJ  COUNT
        INCF    COUNT,W                 ;A PRIPOCITAJ 1 (TAK DOSTANEME POCET PREPNUTI)
        MOVWF   FLSB                    ;HODNOTU Z PREDDELICKY UCHOVAJ V REGISTRY FLSB
PREPNI1	MOVFW	TMP0
	MOVWF	TMR0			;VRAT POVODNU HODNOTU DO RTCC
        bsf	STATUS,RP0
	bsf	TRISA,3
        bcf	STATUS,RP0
	RETURN                          

;********************PODROGRAM CO PREMENI 32 BITOVE CISLO NA BCD KOD ****************************
 


B32_BCD bcf     STATUS,C                	;VYNULUJ BIT PRENOSU
	movlw   d'32'
	movwf   COUNT
	movlw	 6

	clrf    CISLA01
	clrf    CISLA23
	clrf    CISLA45
	clrf	CISLA67
	clrf	CISLA89

loop32  rlf     FLSB, F
	rlf	RTCCPOM, F
	rlf     FMSB, F
	rlf	FMMSB,F
	rlf     CISLA01, F
	rlf     CISLA23, F
	rlf     CISLA45, F
	rlf	CISLA67, F
	rlf	CISLA89, F

;
	decfsz  COUNT, F
	goto    DEKKOR			;dekadicka korekcia sa urobi s kazdym registrom
	RETURN				;AK NEMERIAME DO 1.3 GHz TAK KONIEC
;................................................................................................
;................................................................................................
					
DEKKOR  movlw   CISLA01
	movwf   FSR
	call    BCDKOR			;BCD korekcia

	movlw   CISLA23
	movwf   FSR
	call    BCDKOR			;BCD korekcia

	movlw   CISLA45
	movwf   FSR
	call    BCDKOR			;BCD korekcia

	movlw   CISLA67
	movwf   FSR
	call    BCDKOR			;BCD korekcia

	movlw   CISLA89
	movwf   FSR
	call    BCDKOR			;BCD korekcia

	goto    loop32
;
BCDKOR  movlw   3
	addwf   0,W
	movwf   TMP0
	btfsc   TMP0,3          ; test ci je vysledok > 7
	movwf   0
	movlw   30h
	addwf   0,W
	movwf   TMP0
	btfsc   TMP0,7          ; test ci je vysledok > 7
	movwf   0               ; uloz ako MSD
	RETLW   0





;inicializacia displeju
;------------------------
INILCD		bsf	priznak, 2
		call	cek15m
		movlw	30h
		call	WRCMD
		call	cek15m
		movlw	30h
		call	WRCMD
		call	cek15m
		movlw	30h
		call	WRCMD
		call	cek15m
		bcf	priznak,2
		movlw	28h
		call	WRCMD
		movlw	08h
		call	WRCMD
		movlw	01h		;Display ON
		call	WRCMD
		movlw	06h		;Inkrementacia
		call	WRCMD
		movlw	0ch		;Zapni display
		call	WRCMD
		return


;
;SUBS


;displej
;-------------

WRDATA		bsf	RS			;data pre LCD
		goto	$+2
WRCMD		bcf	RS
		movwf	TMP_D
		bsf		E
		swapf	TMP_D,F
		movlw	0Fh
		andwf	TMP_D,W
		movwf	PORTB
		bcf		E
		btfsc	priznak, 2
		RETURN
		
		bsf		E
		swapf	TMP_D,F
		movlw	0Fh
		andwf	TMP_D,W

		movwf	PORTB
		bcf	E
		btfsc	RS
		call	cek5m
		call	cek15m
		return
;...........................................................................
cakdi	call	cek15m
		call	cek15m
		call	cek15m
		call	cek15m
		call	cek15m
		call	cek15m
		call	cek15m
		call	cek15m
		call	cek15m
		call	cek15m
		call	cek15m
;----------------------------


cek15m		movlw	10		
			movwf	TMP_C3
			decfsz 	TMP_C3
			goto	$+2
			return
			movlw	100		
			movwf	TMP_C4
			decfsz	TMP_C4
			goto	$-1
			goto	$-7
;---------------------------------------------------------------------------
cek5m		movlw	4
			movwf	TMP_C3
			decfsz 	TMP_C3
			goto	$+2
			return
			movlw	5		
			movwf	TMP_C4
			decfsz	TMP_C4
			goto	$-1
			goto	$-7
;------------------------------------------------------------------------

cakSEK		movlw	255
			movwf	TMP_C3
			decfsz 	TMP_C3
			goto	$+2
			return
			movlw	255		
			movwf	TMP_C4
			decfsz	TMP_C4
			goto	$-1
			goto	$-7




END

